import pm4py
import pandas as pd
import numpy as np

from python_helpers import eval_pm, pn_infos

###### Load data and create event logs ######

dat = pd.read_csv("results/haum/event_logfiles_2024-01-18_09-58-52.csv", sep = ";")
dat = dat[dat["date.start"] < "2020-03-13"]
# --> only pre corona (before artworks were updated)
dat = dat[dat["path"] != 106098]
# exclude broken trace

log_path = pm4py.format_dataframe(dat, case_id = "path", activity_key = "event",
                                   timestamp_key = "date.start")

###### Infos for items ######

eval = pd.DataFrame(columns = ["fitness", "precision", "generalizability",
                               "simplicity", "sound", "narcs", "ntrans",
                               "nplaces", "nvariants", "mostfreq"])
for item in log_path.item.unique().tolist():
    eval = pd.concat([eval, pn_infos(log_path, "item", item)])
eval = eval.sort_index()

# Export
eval.to_csv("results/haum/pn_infos_items.csv", sep = ";")
