# setwd("C:/Users/nwickelmaier/Nextcloud/Documents/MDS/2023ss/60100_master_thesis/analysis/code")

library(bupaverse)

dat0 <- read.table("results/haum/event_logfiles_2024-01-18_09-58-52.csv",
                  colClasses = c("character", "character", "POSIXct",
                                 "POSIXct", "character", "integer",
                                 "numeric", "character", "character",
                                 rep("numeric", 3), "character",
                                 "character", rep("numeric", 11),
                                 "character", "character"),
                  sep = ";", header = TRUE)
dat0$event <- factor(dat0$event, levels = c("move", "flipCard", "openTopic",
                                          "openPopup"))

# Select data pre Corona
dat <- dat0[as.Date(dat0$date.start) < "2020-03-13", ]
dat <- dat[dat$path != 106098, ]

dat$start <- dat$date.start
dat$complete <- dat$date.stop

alog <- activitylog(dat,
                    case_id = "path",
                    activity_id = "event",
                    resource_id = "item",
                    timestamps = c("start", "complete"))

dfg_complete <- process_map(alog,
            type_nodes = frequency("absolute", color_scale = "Greys"),
            sec_nodes  = frequency("relative"),
            type_edges = frequency("absolute", color_edges = "#FF6900"),
            sec_edges  = frequency("relative"),
            #rankdir    = "TB",
            render     = FALSE)
export_map(dfg_complete,
           file_name = "results/processmaps/dfg_complete_R.png",
           file_type = "png")

